Dim fdir
Dim fname
Dim fso 
Dim xmlNames
Dim xmlIds
Dim xmlIn

Set fso = CreateObject("Scripting.FileSystemObject")
Set xmlNames = CreateObject("MSXML2.DomDocument.3.0")
Set xmlIn = CreateObject("MSXML2.DomDocument.3.0")
Set xmlIds = CreateObject("MSXML2.DomDocument.3.0")
xmlNames.Async = False
xmlIds.Async = False
xmlIn.Async = False
xmlNames.loadxml "<?xml version=""1.0""?><names/>"
xmlIds.loadxml "<?xml version=""1.0""?><ids/>"
For Each fdir In fso.GetFolder("db").SubFolders
  For Each fname In fdir.Files
  	If right(fname.Name,9)="Names.xml" Then
  		ParseFile fname
  	End If
  Next
Next

xmlNames.save "db/names.xml"
xmlIds.save "db/ids.xml"

Sub ParseFile(f)
	Dim no
	Dim na
	Dim authid
	Dim hash
	Dim max
	Dim topname
	
	xmlIn.Load f.Path
	If xmlIn.parseError.errorCode = 0 Then
		authid = xmlIn.documentElement.attributes.getnameditem("authid").text
		hash = xmlIn.documentElement.attributes.getnameditem("hash").text

		mx=0	
		For Each n In xmlIn.SelectNodes("names/name")
			If CLng("0" & n.SelectSingleNode("count").text) > mx Then
				mx=CLng("0" & n.SelectSingleNode("count").text)
				topname=n.SelectSingleNode("alias").text
			End If
		Next

		Set no = xmlIds.CreateNode(1,"id","")
		xmlIds.DocumentElement.appendchild no			
		no.text = topname
		set na = xmlNames.CreateNode(2,"authid","")	
		no.attributes.setnameditem na
		na.text = authid
		set na = xmlNames.CreateNode(2,"hash","")	
		no.attributes.setnameditem na
		na.text = hash

		
		For Each n In xmlIn.SelectNodes("names/name")
			Set no = xmlNames.CreateNode(1,"name","")
			xmlNames.DocumentElement.appendchild no			
			set na = xmlNames.CreateNode(2,"authid","")	
			no.attributes.setnameditem na
			na.text = authid
			no.text = n.SelectSingleNode("alias").text
		Next
	Else
		'wscript.echo "WARNING: Unable to parse " & f.Path & ": " & xmlIn.parseError.Reason
	End If
End Sub


